
import array as arr
import collections
import glob
import os
import sys
import subprocess
import socket
import os.path
from os import path

from collections import Counter


def filename_list_generator(file_to_open):
    word = ""
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            if not line.startswith("#"):
                for word in line.split(" "):
                    if word.endswith(".nc") or word.endswith("_nc_files"):
                        yield word
                        break

def configname_list_generator(file_to_open):
    word = ""
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            if not line.startswith("#"):
                for word in line.split(" "):
                    if "config_" in word:
                        yield word
                        break

def foldername_list_generator(file_to_open):
    word = ""
    
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            if not line.startswith("#"):
                for word in line.split(" "):
                    if word.startswith("test_"):
                        yield word
                        break

def result_list_generator(file_to_open):
    word = ""
    with open(file_to_open, "r") as file:
        file.read(0)
        for line in file:
            if not line.startswith("#"):
                for word in line.split(" "):
                    if word == '-1' or word == '0' or word == '1':
                        yield(word)
                        break
                
def OSinfo(runthis):
	red = lambda text: '\033[0;31m' + text + '\033[0m'
	osstdout = subprocess.Popen(runthis, shell=True, stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, close_fds=True)
	theInfo = osstdout.communicate()[0].strip()
	if osstdout.returncode!=0:
		print(red(runthis+" FAILED"))
		print >> sys.stderr, osstdout.returncode
		sys.exit()
	# else:
		# print(runthis+" OK")    

def main():
    unfold_icon = '&#11183;'
    fold_icon = '&#11181;'

    current_revision_report = sys.argv[1]

    if os.path.exists(current_revision_report) :
        file_to_open=current_revision_report
    else :
        file_to_open="plein_report_example.txt"


    f=open(file_to_open, "r")
    for line in f :
        if line.startswith("#revision"):
            revision_number = line.split(" ")[1].replace("\n", "")
        elif line.startswith("#build_dir"):
            build_dir = line.split(" ")[1].replace("\n", "")
        elif line.startswith("#arch"):
            arch = line.split(" ")[1].replace("\n", "")
        elif line.startswith("#machine"):
            machine = line.split(" ")[1].replace("\n", "")
            if machine == "jeanzay":
                machine = "Jean-Zay"
            elif machine == "irene":
                machine = "Irene"
            else :
                machine = "other"
        elif line.startswith("#relurl"):
            words = line.split("/")
            words_size = len(words)
            branch = words[words_size-1].replace("\n", "")
            
    folderlist=[]
    for x in foldername_list_generator(file_to_open):
        folderlist.append(x)

    configlist=[]
    for x in configname_list_generator(file_to_open):
        configlist.append(x)
    
    filelist=[]
    for x in filename_list_generator(file_to_open):
        filelist.append(x)

    resultlist=[]
    for x in result_list_generator(file_to_open):
        resultlist.append(x)

    total_records = len(resultlist)

    c = Counter(folderlist)
    nb_level1 = len(c)
    
    my_struncture = dict()

    for i in range(nb_level1):
        my_key1 = list(c.keys())[i] # algo_name
        my_struncture.update({my_key1 : dict()})
        min_range=-1
        for index in range(total_records) :
            if my_key1 == folderlist[index] :
                if min_range == -1 :
                    min_range = index
                    max_range = index
                else :
                    max_range = index
        cc = Counter(configlist[min_range: max_range+1])
        nb_level2 = len(cc)        
        
        for j in range(nb_level2) :
            my_key2 = list(cc.keys())[j] #config_name
            my_struncture[my_key1].update({my_key2:dict()})
            min_range = -1
            for index in range(total_records) :
                if my_key2 == configlist[index] :
                    if min_range == -1 :
                        min_range = index
                        max_range = index
                    else :
                        max_range = index

            ccc = Counter(filelist[min_range: max_range+1])
            nb_level3 = len(ccc)            

            for k in range(nb_level3) :
                my_key3 = list(ccc.keys())[k] #filename
                
                min_range = -1
                for index in range(total_records) :
                    if my_key3 == filelist[index] :
                        if min_range == -1 :
                            min_range = index
                            max_range = index
                        else :
                            max_range = index
                my_struncture[my_key1][my_key2].update({my_key3:resultlist[min_range]})



    nb_algo = len(my_struncture)

    for x in range(nb_algo) :
        algo_name = list(my_struncture.keys())[x]
        nb_config = len(my_struncture[algo_name])
        for y in range(nb_config) :
            config_name = list(my_struncture[algo_name].keys())[y]
            nb_file = len(my_struncture[algo_name][config_name])

    
    algo_names=list(my_struncture.keys())

    nb_files = [0]*nb_algo
    nb_configs = [0]*nb_algo

    for x in range(nb_algo) :
        nb_files[x] = len(my_struncture[list(my_struncture.keys())[x]][list(my_struncture[list(my_struncture.keys())[x]].keys())[0]])
        nb_configs[x] = len(my_struncture[list(my_struncture.keys())[x]])

    
    level1_answer=1
    level2_answer=[1]*nb_algo

    level3_answer = [[]]*nb_algo
    for x in range(nb_algo) :
        level3_answer[x] = [1]*nb_configs[x]

    level4_answer = [[[]]]*nb_algo
    for x in range(nb_algo) :
        level4_answer[x] = [[]]*nb_configs[x]
        for y in range(nb_configs[x]) :
            level4_answer[x][y] = [1]*nb_files[x]
            for z in range(nb_files[x]) :
                x_dict = my_struncture
                y_dict = x_dict[list(x_dict.keys())[x]]
                z_dict = y_dict[list(y_dict.keys())[y]]
                level4_answer[x][y][z] = int(z_dict[list(z_dict.keys())[z]])

    index=0
    for x in range(nb_algo):
        for y in range(len(level3_answer[x])):
            for z in range(len(level4_answer[x][y])):
                level3_answer[x][y] = min(level4_answer[x][y][z], level3_answer[x][y])
            index+=1

    index=0
    for x in range(len(level2_answer)):
        for y in range(len(level3_answer[x])):
            level2_answer[x] = min(level2_answer[x], level3_answer[x][y])
        index+=1

    for x in range(len(level2_answer)):
        level1_answer = min(level1_answer, level2_answer[x])

    # ans_dict = {-1: 'Failed', 0: 'Initialized', 1: 'Passed'}
    ans_dict = {-1: '&#10060;', 0: '&#10062', 1: '&#9989;'}

    algo_list = list(my_struncture.keys())


    config_list=[]
    for x in range(nb_algo) :
        my_list = list(my_struncture[list(my_struncture.keys())[x]].keys())
        for y in range(len(my_list)) :
            config_list.append(my_list[y])


    file_list=[]
    for x in range(nb_algo) :
        l = list(my_struncture.keys())[x]
        ll = list(my_struncture[l].keys())[0]
        lll = list(my_struncture[l][ll].keys())
        for y in range(len(lll)) :
            file_list.append(lll[y])

    
    old_config_list=config_list[:]
    for x in range(len(config_list)) :
        word = config_list[x]
        new_word=''
        for i in range(len(word)) :
            if word[i]=="@" :
                new_word = word[i+1:]
                break
        # old_config_list.append(new_word)
        old_config_list[x]=new_word
        word = new_word.replace("config_", "CONFIG: ")
        new_word = word.replace("_", " ")
        config_list[x] = new_word


    for x in range(len(file_list)) :
        word = file_list[x]
        new_word=''
        for i in range(len(word)) :
            if word[i]=="@" :
                new_word = word[i+1:]
                break
        file_list[x] = new_word

    for x in range(len(file_list)) :
        word = file_list[x]
        new_word=''
        for i in range(len(word)) :
            if word[i]=="@" :
                new_word = word[i+1:]
                break
        file_list[x] = new_word

    if os.path.exists("xios_table_"+revision_number+".js") : 
        print("table for revision "+revision_number+" exists already")
    else :
        f=open("xios_table_"+revision_number+".js", "w")
        f.write("document.write(`\n")
        f.write("<html>\n")
        f.write("<head>\n")
        f.write("</head>\n")
        f.write("<body>\n")
        f.write("   <div id=\"navborder_"+revision_number+"\" class=\"class_navborder\">\n")
        f.write("       <p id=\"xiosinfo\">Information of XIOS source:</p>\n")
        f.write("       <table id=\"xiosinfotable\">\n")
        f.write("           <tr><td>Branch</td><td><em>"+branch+"</em></td></tr>\n")
        f.write("           <tr><td>Revision</td><td><em>"+revision_number+"</em></td></tr>\n")
        f.write("           <tr><td>Machine</td><td><em>"+machine+"</em></td></tr>\n")
        f.write("           <tr><td>Architecture</td><td><em>"+arch+"</em></td></tr>\n")
        f.write("           <tr><td>Compile mode</td><td><em>prod</em></td></tr>\n")
        f.write("           <tr><td>Build directory</td><td><em>"+build_dir+"</em></td></tr>\n")
        f.write("       </table>\n")
        f.write("   </div>\n")   
        f.write("   <table id=\"xiostable_"+revision_number+"\" class=\"class_xiostable\">\n")
        f.write("       <thead></thead>\n")
        f.write("       <tfoot></tfoot>\n")
        f.write("       <tbody>\n")
        f.write("           <tr class=\"level1\" style=\"background-color:#85c1e9;font-size:1.6em;\" >\n")
        f.write("               <td>"+revision_number+" XIOS Unit tests <span id=\""+revision_number+"_icon_level1_1\" onclick=\"level1_unfold(\'"+revision_number+"\');\" style=\"display:inline\" title=\"unfold\">"+unfold_icon+"</span>\n")
        f.write("                                   <span id=\""+revision_number+"_icon_level1_2\" onclick=\"level1_fold(\'"+revision_number+"\');\" style=\"display:none\" title=\"fold\">"+fold_icon+"</span></td>\n")
        f.write("               <td><div class=\"dropdown\"><button class=\"dropbtn\">&#128270;</button>\n")
        f.write("               <div class=\"dropdown-content\">\n")
        f.write("               <a href=\"#\" onclick=\"show_xios_info(\'"+revision_number+"\')\">show/hide XIOS info</a>\n")
        f.write("               <a href=\"#\" onclick=\"show_plein_report(\'"+revision_number+"\')\">show plein report</a>\n")
        f.write("               </div></div></td>\n")
        f.write("               <td></td>\n")
        f.write("               <td></td>\n")
        f.write("               <td style=\"border-left: 0px\" class=\"testanswer\">"+ ans_dict[level1_answer]+"</td>\n")
        f.write("               <td></td>\n")
        f.write("               <td></td>\n")
        f.write("               <td></td>\n")
        f.write("           </tr>\n")
        
    
        x_offset = 0
        y_offset = 0
        for x in range(nb_algo):
            f.write("           <tr class=\"level2\" data-algo-type=\""+algo_list[x]+"\" style=\"display:none;background-color:#aed6f1;font-size:1.4em;\">\n")
            f.write("               <td></td>\n")
            f.write("               <td>"+algo_list[x]+" <span id=\""+revision_number+"_icon_level2_"+algo_list[x]+"_1\" onClick=\"level2_unfold(\'"+revision_number+"\',\'"+algo_list[x]+"\');\" style=\"display:inline\" title=\"unfold\">"+unfold_icon+"</span>\n")
            f.write("                                    <span id=\""+revision_number+"_icon_level2_"+algo_list[x]+"_2\" onClick=\"level2_fold(\'"+revision_number+"\',\'"+algo_list[x]+"\');\" style=\"display:none\" title=\"fold\">"+fold_icon+"</span></td>\n")
            f.write("               <td><div class=\"dropdown\"><button class=\"dropbtn\">&#128270;</button>\n")
            f.write("               <div class=\"dropdown-content\">\n")
            f.write("               <a href=\"#\" onclick=\"show_param_"+algo_list[x]+"(\'"+revision_number+"\')\">show user_params.def</a>\n")
            f.write("               </div></div></td>\n")
            f.write("               <td> </td>\n")
            f.write("               <td> </td>\n")
            f.write("               <td class=\"testanswer\">"+ans_dict[level2_answer[x]]+"</td>\n")
            f.write("               <td> </td>\n")
            f.write("               <td> </td>\n")
            f.write("           </tr>\n")

            for y in range(nb_configs[x]):
                f.write("           <tr class=\"level3_"+algo_list[x]+"\" data-algoconfig-type=\""+algo_list[x]+"_"+old_config_list[y_offset]+"\" style=\"display:none;background-color:#d6eaf8;font-size:1.2em;\">\n")
                f.write("               <td></td>\n")
                f.write("               <td></td>\n")
                f.write("               <td>"+config_list[y_offset]+" <span id=\""+revision_number+"_icon_level3_"+algo_list[x]+"_"+old_config_list[y_offset]+"_1\" onClick=\"level3_unfold(\'"+revision_number+"\',\'"+algo_list[x]+"_"+old_config_list[y_offset]+"\');\" style=\"display:inline\" title=\"unfold\">"+unfold_icon+"</span>\n")
                f.write("                                             <span id=\""+revision_number+"_icon_level3_"+algo_list[x]+"_"+old_config_list[y_offset]+"_2\" onClick=\"level3_fold(\'"+revision_number+"\',\'"+algo_list[x]+"_"+old_config_list[y_offset]+"\');\" style=\"display:none\" title=\"fold\">"+fold_icon+"</span></td>\n")
                f.write("               <td><div class=\"dropdown\"><button class=\"dropbtn\">&#128270;</button>\n")
                f.write("               <div class=\"dropdown-content\">\n")
                f.write("               <a href=\"#\" onclick=\"show_param_"+algo_list[x]+"_config(\'"+revision_number+"\',"+repr(old_config_list[y_offset])+")\">show all_param.def</a>\n")
                f.write("               <a href=\"#\" onclick=\"show_user_param_"+algo_list[x]+"_config(\'"+revision_number+"\',"+repr(old_config_list[y_offset])+")\">show user_param.def</a>\n")
                f.write("               </div></div></td>\n")
                y_position=y_offset
                y_offset+=1
                f.write("               <td></td>\n")
                f.write("               <td></td>\n")
                f.write("               <td class=\"testanswer\">"+ ans_dict[level3_answer[x][y]]+"</td>\n")
                f.write("               <td></td>\n")
                f.write("           </tr>\n")

                for z in range(nb_files[x]):
                    f.write("           <tr class=\"level4_"+algo_list[x]+"_"+old_config_list[y_position]+"\" style=\"display:none;background-color:#ebf5fb;\">\n")
                    f.write("               <td></td>\n")
                    f.write("               <td></td>\n")
                    f.write("               <td></td>\n")
                    f.write("               <td>"+file_list[x_offset+z]+"</td>\n")
                    f.write("               <td></td>\n")
                    f.write("               <td></td>\n")
                    f.write("               <td></td>\n")
                    f.write("               <td class=\"testanswer\">"+ ans_dict[level4_answer[x][y][z]]+"</td>\n")
                    f.write("            </tr>\n")

            x_offset = x_offset+nb_files[x]

        f.write("       </tbody>\n")
        f.write("   </table>\n")
        # f.write("<script>\n")
        # f.write("   var ans = document.getElementsByClassName('testanswer')\n")
        # f.write("   for (var i = 0; i < ans.length; i++) {\n")
        # f.write("       var cell = ans[i]\n")
        # f.write("       if (cell.textContent == 'Passed') {\n")
        # f.write("           cell.classList.add('green') }\n")
        # f.write("       else if (cell.textContent == 'Failed') {\n")
        # f.write("           cell.classList.add('red') }\n")
        # f.write("       else if (cell.textContent == 'Initialized') {\n")
        # f.write("           cell.classList.add('goldenrod') }\n")
        # f.write("   }\n")

        # f.write("\n\n")
   
        # f.write("</script>\n")

        f.write("</body>\n")
        f.write("</html>\n")
        f.write("`);\n")



        f.close()

    
if __name__== "__main__":
  main()


